\usepackage{pifont}  % cmarks
\usepackage{rotating} % Rotating table
\usepackage{booktabs}
\usepackage[table]{xcolor}
\usepackage{subfigure}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% pgfplots

% \usepackage{pgfplots}
% \pgfplotsset{compat=newest,
%     width=6cm,
%     height=3cm,
%     scale only axis=true,
%     max space between ticks=25pt,
%     try min ticks=5,
%     every axis/.style={
%         axis y line=left,
%         axis x line=bottom,
%         axis line style={thick,->,>=latex, shorten >=-.4cm}
%     },
%     every axis plot/.append style={thick},
%     tick style={black, thick}
% }
% \tikzset{
%     semithick/.style={line width=0.8pt},
% }
% \usepgfplotslibrary{groupplots}
% \usepgfplotslibrary{dateplot}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% refs

\usepackage{prettyref}

\newrefformat{ch}{chapter \ref{#1}}  % on page \pageref{#1}}
\newrefformat{sec}{section \ref{#1}}  % on page \pageref{#1}}
\newrefformat{subsec}{Section \ref{#1}}  % on page \pageref{#1}}
\newrefformat{eq}{Equation \ref{#1}}  % on page \pageref{#1}}
\newrefformat{thm}{Theorem \ref{#1}}  % on page \pageref{#1}}
\newrefformat{fig}{Figure \ref{#1}}  % on page \pageref{#1}}
\newrefformat{tab}{Table \ref{#1}}  % on page \pageref{#1}}
\newrefformat{alg}{Algorithm \ref{#1}}  % on page \pageref{#1}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% bib

\usepackage[round]{natbib}
 	\renewcommand{\cite}[1]{\citep{#1}}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% maths

\usepackage{amsthm, amsmath, amsfonts, amssymb, amsthm, mathtools}
\usepackage[ruled, vlined]{algorithm2e}

\theoremstyle{definition}

\newtheorem{exmp}{Example}[section]
\newtheorem{theorem}{Theorem}
\newtheorem{lemma}{Lemma}
\newtheorem{corollary}{Corollary}
\newtheorem{assumption}{Assumption}
\newtheorem{defi}{Definition}
\newtheorem{fact}{Fact}
\newtheorem{exm}{Example}
\newtheorem{remark}{Remark}

\usepackage{afterpage}
\newcommand\blankpage{%
    \null
    \thispagestyle{empty}%
    \addtocounter{page}{-1}%
    \newpage}

% reads very incoherent, not clear what the purpose is \setcounter{chapter}{-1}  % chapters start at 0
\usepackage{enumerate}% http://ctan.org/pkg/enumerate

% capitalization
\usepackage{mfirstuc}

% https://tex.stackexchange.com/a/282/226150
\usepackage[section]{placeins}

% https://www.overleaf.com/learn/latex/Typesetting_quotations
\usepackage{dirtytalk}